﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CorrecaoElevador
{
    class Programa
    {
        public class Elevador
        {
            private int andar_atual { get; set; }
            private int total_andares { get; set; }
            private int capacidade { get; set; }
            private int lotacao { get; set; }

            public Elevador()
            {
                this.lotacao = 0;
                this.andar_atual = 0;

                Console.Write("Informe o total de andares do prédio: ");
                do
                {
                    this.total_andares = Convert.ToInt32(Console.ReadLine());
                    if (this.total_andares < 1)
                        Console.Write("Número de andares inválido. Maior ou igual a 1. Tente novamente: ");
                } while (this.total_andares < 1);
                Console.Write("Informe quantas pessoas podem entrar simultaneamente: ");
                do
                {
                    this.capacidade = Convert.ToInt32(Console.ReadLine());
                    if (this.capacidade < 1)
                        Console.Write("Capacidade inválida. Somente maior do que 0. Tente novamente: ");

                } while (this.capacidade < 1);
            }

            public void EntrarPessoa()
            {
                if (this.capacidade > this.lotacao) //if(this.lotacao <= this.capacidade)
                    this.lotacao++;
                else
                {
                    Console.WriteLine("Não é permitido entrar mais pessoas.");
                    Console.ReadKey();
                }
            }

            public void SairPessoa()
            {
                if (this.lotacao > 0)
                    this.lotacao--;
                else
                {
                    Console.WriteLine("O elevador já está vazio. ");
                    Console.ReadKey();
                }
            }

            public void Subir()
            {
                if (this.andar_atual < this.total_andares)
                    this.andar_atual++;
                else
                {
                    Console.WriteLine("Já estamos no último andar");
                    Console.ReadKey();
                }
            }

            public void Descer()
            {
                if (this.andar_atual > 0)
                    this.andar_atual--;
                else
                {
                    Console.WriteLine("Já estamos no térreo.");
                    Console.ReadKey();
                }
            }

            public void ConsultarElevador()
            {
                Console.WriteLine("Andar atual: {0}\nPessoas: {1}", this.andar_atual, this.lotacao);
            }
        }
        
        static void Main()
        {
            Elevador teste = new Elevador();
            string opc="0";
            do
            {
                Console.Clear();
                teste.ConsultarElevador();
                Console.WriteLine("\n\n\t\t1 - Entrar uma pessoa no elevador");
                Console.WriteLine("\t\t2 - Sair uma pessoa do elevador");
                Console.WriteLine("\t\t3 - Subir um andar");
                Console.WriteLine("\t\t4 - Descer um andar");
                Console.WriteLine("\t\t5 - Sair");
                Console.Write("\n\t\tEscolha uma opção: ");
                opc=Console.ReadLine();

                switch (opc) { 
                    case "1":
                        teste.EntrarPessoa();
                        break;
                    case "2":
                        teste.SairPessoa();
                        break;
                    case "3":
                        teste.Subir();
                        break;
                    case "4":
                        teste.Descer();
                        break;
                    case "5":
                        break;
                    default:
                        Console.WriteLine("Opção inválida!");
                        break;
                    
                }
                //Console.ReadKey();
            } while (opc != "5");


            //Console.ReadKey();
        }
    }
}
